'Compilable Example:
#Compiler PBWin 9
#Compile Exe
#Dim All
#Debug Error On
#Debug Display On
#Include "win32api.inc"
#Include "commctrl.inc"
#Resource "gblaunch.pbr"

$ver = "v1.0"
%IconMargin  = 3

%IDC_ListBox         = 500
%IDM_RemoveSelection = 501
%IDM_OpenLocation    = 502
%IDM_Sep             = 503
%IDM_NamesOnly       = 504
%IDM_RemoveAll       = 505
%IDM_TopMost         = 506
%IDM_CommandLine     = 507
%IDM_Help            = 508
%IDM_AutoSize        = 509
%IDM_OpenWithCommand = 510
%IDM_RollUp          = 511
%IDM_HotKey          = 512
%IDM_Font            = 513
%IDM_ClearCLHistory  = 514
%IDM_CleanCLHistory  = 515
%IDM_TextOnly        = 516
%IDM_IconsOnly       = 517
%IDM_TextAndIcons    = 518
%IDM_About           = 519
%IDM_Launch          = 520
%IDM_Right           = 521
%IDM_AutoSizeOnce    = 522
%IDM_IndexDesktop    = 523
%IDM_EditDoc         = 524
%IDM_EditEXE         = 525
%IDM_IncludeExt      = 526
%IDM_AddFromClipboard= 527
%IDM_ShowPath        = 528
%IDM_SortAscend      = 529
%IDM_SortDescend     = 530
%IDM_SaveList        = 531
%IDM_OpenList        = 532
%IDM_CycleMode       = 533
%IDM_Left            = 534
%IDM_OpenListFolder  = 535
%IDM_Summary         = 536
%IDM_AddFile         = 537
%IDM_AddFolder       = 538
%IDM_ExitNoSave      = 539
%IDM_CopyPath        = 540
%IDM_CopyPaths       = 541
%IDM_Merge           = 542
%IDM_IndexSelect     = 543
%IDM_ToggleDebug     = 544
%IDM_ClearConsole    = 545
%IDM_AltColors       = 546
%IDM_SortByType      = 547

%IDM_Settings        = 1000  '1000-1100 reserved

Declare Function Sub1( p1 As Any ) As Dword
Declare Function Sub2( p1 As Any, p2 As Any ) As Dword
Declare Function Sub3( p1 As Any, p2 As Any, p3 As Any ) As Dword
Declare Function Sub5( p1 As Any, p2 As Any, p3 As Any, p4 As Any, p5 As Any ) As Dword

Global hDlg,hContext,hOpenList,hHook,hFont,hBMP,hConsole,fHandlesL(), fHandlesS(), L(), S() As Dword
Global Selection, NamesOnly, TopMost, AutoSize, CommandLine, DisplayMode,IncludeExt As Long
Global iMsgCount,ExitNoSave,SortByType As Long
Global imgWL,imgHL,imgWS,imgHS,RowHeight,RollUp, OldHeight,FontSize,FontAttr, TextMargin,MergeOpen,Debug,AltColors As Long
Global fNames(),FontName,ExeFiles,DocFiles,Caption,CFN,LastSaveAs As String

Function PBMain() As Long
  If InstanceTest = 0 Then MsgBox "Previous instance detected!", %MB_Ok + %MB_IconExclamation, "gbLaunch" : Exit Function
  Dialog New Pixels, 0, "gbLaunch",300,300,200,200, %WS_ThickFrame Or %WS_SysMenu Or %WS_MinimizeBox, 0 To hDlg
  Dialog Set Icon hDlg, "logo"
  DragAcceptFiles hDlg, %True
  CreateContextMenu
  Control Add ListBox, hDlg, %IDC_ListBox,,0,0,200,200, %WS_Child Or %WS_Visible Or %LBS_OwnerDrawFixed Or %LBS_HasStrings Or %LBS_Notify Or %WS_TabStop Or %WS_VScroll Or %LBS_NoIntegralHeight, %WS_Ex_ClientEdge
  Control Send hDlg, %IDC_ListBox, %LB_SetColumnWidth,99999,0
  Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local x,y,w,h,iResult,OldCommand As Long, temp$, pt As Point
   Local rc As Rect, lpdis As DrawItemStruct Ptr, wszTxt As Asciiz * 300  'WStringZ * 300
   Static StartItem, EndItem, DragInWork As Long
   Select Case Cb.Msg
       Case %WM_InitDialog
           ReDim L(0),S(0)
           BuildAcceleratorTable
           GetImageSizes
           CreateTempHTM
           If IsFalse IsFolder(EXE.Path$ + "lists") Then MkDir EXE.Path$ + "lists"
           Settings_INI "get"
'           iResult = RegisterHotKey (hDlg, %IDM_HotKey, %HotKeyF_Control, %VK_L)
'           If iResult = 0 Then MsgBoxX "Cannot register Ctrl-L hot key!", %MB_Ok+%MB_IconExclamation, "Register Ctrl-L Hotkey"
           SetDisplayModeMenus
           Font New FontName, FontSize, FontAttr To hFont
           SetRowHeight
           Control Set Font hDlg, %IDC_ListBox, hFont
           If Len(Trim$(Command$)) Then AddNewApplication Command$
           ListBox Select hDlg, %IDC_ListBox,Selection
           iResult = Selection
           BuildListBox
           SetOnTop
           ListBox Select hDlg, %IDC_ListBox,iResult
       Case %WM_Command
           Select Case Cb.Ctl
               Case %IDM_Launch
                   LaunchSelection
               Case %IDM_About
                   MsgBoxX "gbLaunch " + $ver, %MB_Ok+%MB_IconInformation, "About"
               Case %IDM_Help
                   temp$ = "http://www.garybeene.com/sw/gblaunch.htm"
                   iResult = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)
               Case %IDM_OpenWithCommand
                   OldCommand = CommandLine
                   CommandLine = 1
                   LaunchSelection
                   CommandLine = OldCommand
               Case %IDM_OpenLocation
                   ListBox Get Select hDlg, %IDC_ListBox To iResult
                   ShellExecute(hDlg, "Open", (PathName$(Path, fNames(iResult))), $Nul, $Nul, %SW_Restore)
               Case %IDM_RemoveSelection
                   ListBox Get Count hDlg, %IDC_ListBox To iResult
                   If iResult Then
                       If Debug Then cPrint "IDM_RemoveSelection"
                       ListBox Get Select hDlg, %IDC_ListBox To iResult
                       ListBox Delete hDlg, %IDC_ListBox, iResult
                       Array Delete fNames(iResult)
                       If fHandlesL(iResult) Then DestroyIcon fHandlesL(iResult)
                       If fHandlesS(iResult) Then DestroyIcon fHandlesS(iResult)
                       Array Delete fHandlesL(iResult)
                       Array Delete fHandlesS(iResult)
                       ReDim Preserve fNames(UBound(fNames)-1), fHandlesL(UBound(fNames)), fHandlesS(UBound(fNames))
                       If AutoSize Then AutoSizeListBox
                       ListBox Get Count hDlg, %IDC_ListBox To h
                       If iResult <= h Then Selection = iResult Else Selection = iResult - 1
                       If iResult < 1 Then iResult = 1
                       ListBox Select hDlg, %IDC_ListBox, Selection
                   End If
               Case %IDM_RemoveAll
                   If MsgBoxX("Are you sure?", %MB_OkCancel+%MB_IconQuestion, "Remove All Apps From List") = %IdOk Then
                      If Debug Then cPrint "IDM_RemoveAll"
                      ListBox Reset hDlg, %IDC_ListBox
                      ClearHandles
                      ReDim fNames(0), fHandlesL(0), fHandlesS(0)
                      Selection = 0
                   End If
               Case %IDM_NamesOnly
                   NamesOnly = NamesOnly Xor 1
                   Menu Set State hContext, ByCmd %IDM_NamesOnly, NamesOnly * 8
                   BuildListBox
               Case %IDM_RollUp
                   Rollup = RollUp Xor 1
                   Menu Set State hContext, ByCmd %IDM_RollUp, RollUp * 8
                   Dialog Get Client hDlg To w,h
                   If (h<5) And Rollup = 0 Then Dialog Set Client hDlg, w, OldHeight
                   If RollUp Then RollUpWindow
               Case %IDM_AutoSize
                   AutoSize = AutoSize Xor 1
                   Menu Set State hContext, ByCmd %IDM_AutoSize, AutoSize * 8
                   If AutoSize Then AutoSizeListBox
               Case %IDM_TopMost
                   TopMost = TopMost Xor 1
                   Menu Set State hContext, ByCmd %IDM_TopMost, TopMost * 8
                   SetOnTop
               Case %IDM_CommandLine
                   CommandLine = CommandLine Xor 1
                   Menu Set State hContext, ByCmd %IDM_CommandLine, CommandLine * 8
               Case %IdOk
                   'Enter key
                   LaunchSelection
               Case %IDC_ListBox
                   Select Case Cb.CtlMsg
                       Case %LBN_DblClk
                          'double click
                          LaunchSelection
                   End Select
               Case %IDM_HotKey
                   Dialog Show State hDlg, %SW_Restore
               Case %IDM_Font
                   SelectListBoxFont
               Case %IDM_ClearCLHistory
                   If MsgBoxX("Are you sure?", %MB_OkCancel+%MB_IconQuestion, "Clear Command Line History") = %IdOk Then
                      Kill EXE.Path$ + "clhistory.txt"
                   End If
               Case %IDM_TextOnly
                   DisplayMode = 1 : SetDisplayModeMenus : SetRowHeight : BuildListBox
               Case %IDM_TextAndIcons
                   DisplayMode = 2 : SetDisplayModeMenus : SetRowHeight : BuildListBox
               Case %IDM_IconsOnly
                   DisplayMode = 3 : SetDisplayModeMenus : SetRowHeight : BuildListBox
                           Case %IDM_CleanCLHistory
                   CleanCLHistory
               Case %IDM_Left
                   'PostMessage hDlg, %WM_CANCELMODE, 0, 0
                   '? "arrow"
                   'keybd_event(%VK_Escape,0,0,0)
               Case %IDM_Right
                   BuildListMenu
                   Dialog Get Loc hDlg To x,y
                   x = x + 50 : y = y + 100
                   TrackPopupMenu hContext, %TPM_LeftAlign, x, y, 0, Cb.Hndl, ByVal 0
                   Function = 1 : Exit Function
               Case %IDM_AutoSizeOnce : AutoSizeListBox
               Case %IDM_EditDoc      : EditDocFileList
               Case %IDM_EditExe      : EditExeFileList
               Case %IDM_IncludeExt
                   IncludeExt = IncludeExt Xor 1
                   Menu Set State hContext, ByCmd %IDM_IncludeExt, IncludeExt * 8
                   BuildListBox
               Case %IDM_AddFromClipboard : AddFromClipBoard
               Case %IDM_ShowPath         : ShowPath
               Case %IDM_SortAscend       : SortList(0) : BuildListBox
               Case %IDM_SortDescend      : SortList(1) : BuildListBox
               Case %IDM_SaveList         : SaveList
               Case 1001 To 1100      'up to 100 saved lists
                   Menu Get Text hOpenList, ByCmd Cb.Ctl To temp$
                   temp$ = EXE.Path$ + "lists\" + temp$
                   Listing_INI IIf$(MergeOpen,"merge","get"),temp$
                   BuildListBox
                   If MergeOpen = 0 Then ListBox Select hDlg, %IDC_ListBox,1  'keep selection same if can
               Case %IDM_CycleMode
                   If DisplayMode = 3 Then
                       DisplayMode = 1
                   ElseIf DisplayMode = 1 Then
                       DisplayMode = 2
                   ElseIf DisplayMode = 2 Then
                       DisplayMode = 3
                   End If
                   SetDisplayModeMenus : SetRowHeight : BuildListBox
               Case %IDM_OpenListFolder
                   ShellExecute(hDlg, "Open", (EXE.Path$ + "lists"), $Nul, $Nul, %SW_Restore)
               Case %IDM_Summary      : DisplaySummary
               Case %IDM_AddFile
                   temp$ = AddFile
                   If Len(temp$) Then AddNewApplication temp$
                   BuildListBox
                   ListBox Get Count hDlg, %IDC_ListBox To Selection
                   ListBox Select hDlg, %IDC_ListBox,Selection
               Case %IDM_AddFolder
                   temp$ = AddFolder
                   If Len(temp$) Then AddNewApplication temp$
                   BuildListBox
                   ListBox Get Count hDlg, %IDC_ListBox To Selection
                   ListBox Select hDlg, %IDC_ListBox,Selection
               Case %IDM_ExitNoSave
                   ExitNoSave = 1
                   Dialog End hDlg
                   Function = 1
               Case %IDM_CopyPath
                   Clipboard Reset
                   ListBox Get Select hDlg, %IDC_ListBox To iResult
                   Clipboard Set Text fNames(iResult)
               Case %IDM_CopyPaths
                   Clipboard Reset
                   Clipboard Set Text Join$(fNames(),$CrLf)
               Case %IDM_Merge
                   MergeOpen = MergeOpen Xor 1
                   Menu Set State hContext, ByCmd %IDM_Merge, MergeOpen * 8
               Case %IDM_IndexSelect  : IndexSelectFolder
               Case %IDM_IndexDesktop : IndexDeskTopFolder
               Case %IDM_ClearConsole : ClearConsole
               Case %IDM_ToggleDebug
                   Debug = Debug Xor 1
                   If Debug Then
                      cPrint "Console Display Enabled" + $CrLf + String$(30,"=")
                   Else
                      FreeConsole
                      hConsole = 0
                   End If
               Case %IDM_AltColors
                   AltColors = AltColors Xor 1
                   Menu Set State hContext, ByCmd %IDM_AltColors, AltColors * 8
                   BuildListBox
               Case %IDM_SortByType
                   SortByType = SortByType Xor 1
                   Menu Set State hContext, ByCmd %IDM_SortByType, SortByType * 8
           End Select
       Case %WM_Size
           Dialog Get Client hDlg To w,h
           Control Set Size hDlg, %IDC_ListBox, w,h
      Case %WM_NCLButtonDblClk
          RollUpWindow
          Function = 1 : Exit Function
      Case %WM_ContextMenu
           BuildListMenu
           x = Lo(Integer,Cb.LParam) : y = Hi(Integer, Cb.LParam)
           TrackPopupMenu hContext, %TPM_LeftAlign, x, y, 0, Cb.Hndl, ByVal 0
           Function = 1 : Exit Function
      Case %WM_DropFiles
           temp$ = GetDroppedFileName(Cb.WParam)
           DragFinish Cb.WParam
           AddNewApplication temp$
           BuildListBox
           ListBox Get Count hDlg, %IDC_ListBox To Selection
           ListBox Select hDlg, %IDC_ListBox,Selection
      Case %WM_Destroy
'           UnregisterHotKey hDlg, %IDM_HotKey
           Graphic Bitmap End
           ClearHandles
           If ExitNoSave = 0 Then Settings_INI "save"
     Case %WM_SetCursor
         GetCursorPos pt
         ScreenToClient GetDlgItem(hDlg,%IDC_ListBox), pt
         If GetDlgCtrlID (Cb.WParam) <> %IDC_ListBox Then Exit Function
         Select Case Hi(Word, Cb.LParam)  'monitors lbuttondown, mousemose, lbuttonup
               Case %WM_LButtonDown
                  DragInWork = 1
                  Control Send hDlg, %IDC_ListBox, %LB_ItemFromPoint, 0, Mak(Long, pt.x, pt.y) To StartItem
                  EndItem = 0
               Case %WM_MouseMove
                  If (StartItem < 64000) And DragInWork Then
                     Control Send hDlg, %IDC_ListBox, %LB_ItemFromPoint, 0, Mak(Long, pt.x, pt.y) To EndItem
                     If StartItem <> EndItem Then ReArrangeListBoxItems(StartItem,EndItem) : BuildListBox
                     DragInWork = 0
                  End If
         End Select
     Case %WM_DrawItem                  ' draw items in ownerdrawn control
        If Cb.WParam = %IDC_ListBox Then    ' CBWPARAM holds control's ID
            lpdis = Cb.LParam            ' CBLPARAM points to a DRAWITEMSTRUCT structure
            If @lpdis.itemID = &HFFFFFFFF Then Exit Function 'if list is empty
            rc = @lpdis.rcItem

            Select Case @lpdis.itemAction
                Case %ODA_DRAWENTIRE, %ODA_SELECT
                        If DisplayMode = 1 Then TextMargin = 3
                        If DisplayMode = 2 Then TextMargin = imgWS+3*%IconMargin
                        ' Draw current item's text
                        If (@lpdis.itemState And %ODS_SELECTED) = 0 Then                ' Not selected
                            If AltColors Then
                               If (@lpdis.itemID+1) Mod 2 Then
                                    FillRect @lpdis.hDC, rc, %rgb_LightBlue    ' Clear background
                                    SetBkColor @lpdis.hDC, %rgb_LightBlue           ' Text background
                                Else
                                    FillRect @lpdis.hDC, rc, GetSysColorBrush(%COLOR_WINDOW)    ' Clear background
                                    SetBkColor @lpdis.hDC, GetSysColor(%COLOR_WINDOW)           ' Text background
                                End If
                            Else
                                FillRect @lpdis.hDC, rc, GetSysColorBrush(%COLOR_WINDOW)    ' Clear background
                                SetBkColor @lpdis.hDC, GetSysColor(%COLOR_WINDOW)           ' Text background
                            End If
                            SetTextColor @lpdis.hDC, GetSysColor(%COLOR_WINDOWTEXT)     ' Text color
                        Else                                                            ' Is Selected
                            rc.nRight = TextMargin - 2                                 ' Adjust right side of rect
                            FillRect @lpdis.hDC, rc, GetSysColorBrush(%COLOR_HighLight)    ' Bitmap background
                            rc.nLeft = TextMargin - 2                                  ' Adjust left side of rect
                            rc.nRight = @lpdis.rcItem.nRight                            ' And right side of rect
                            FillRect @lpdis.hDC, rc, GetSysColorBrush(%COLOR_HIGHLIGHT) ' "Selected" background
                            SetBkColor @lpdis.hDC, GetSysColor(%COLOR_HIGHLIGHT)        ' Text background
                            SetTextColor @lpdis.hDC, GetSysColor(%COLOR_HIGHLIGHTTEXT)  ' Text color
                        End If

                        ' get current item's text
                        ListBox Get Text Cb.Hndl, %IDC_ListBox, @lpdis.itemID + 1 To wszTxt
                        ' Adjust text position slightly
                        Incr rc.nTop
                        rc.nLeft = TextMargin
                        ' Draw current item's text
                    If DisplayMode < 3 Then
                        DrawText @lpdis.hDC, wszTxt, Len(wszTxt), rc, %DT_SINGLELINE Or %DT_LEFT Or %DT_VCENTER
                    End If

                    ' Draw current item's bitmap
                    If DisplayMode =2 Then
                        If fHandlesS(@lpdis.itemID+1) Then
                            DrawState @lpdis.hDC, 0&, 0&, fHandlesS(@lpdis.itemID+1), 0&, %IconMargin, rc.nTop + 2, 0, 0, %DST_Icon
                        End If
                    ElseIf DisplayMode =3 Then
                        If fHandlesL(@lpdis.itemID+1) Then
                            DrawState @lpdis.hDC, 0&, 0&, fHandlesL(@lpdis.itemID+1), 0&, %IconMargin+45, rc.nTop + 2, 0, 0, %DST_Icon
                        End If
                    End If
                    Function = %TRUE
                    Exit Function
            End Select
        End If

   End Select
End Function


Sub Settings_INI(Task$)
   If Debug Then cPrint LCase$(FuncName$)
   Local i,x,y As Long
   Local xResult, yResult, tempz, INIFileName As Asciiz * %Max_Path

   'set ini filename
   INIFileName = EXE.Path$ + "gblaunch.ini"

   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "400", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "400", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult$), Val(yResult$)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "200", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "100", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult$), Val(yResult$)   'width/height

      'get value for string variables
      GetPrivateProfileString "All", "LastSaveAs", "settings", tempz, %Max_Path, INIFileName
      LastSaveAs = tempz

      GetPrivateProfileString "All", "FontName", "Consolas", tempz, %Max_Path, INIFileName
      FontName = tempz

      GetPrivateProfileString "All", "EXEFiles", ".exe.bat", tempz, %Max_Path, INIFileName
      ExeFiles = tempz

      GetPrivateProfileString "All", "DocFiles", ".htm.pbr.hlp.jpg.gif.ico.png.bmp.doc.xls.txt.bas.inc.ini.log", tempz, %Max_Path, INIFileName
      DocFiles = tempz

      'get value for numeric variable
      Getprivateprofilestring "All", "DisplayMode", "2", tempz, %Max_Path, INIFileName
      DisplayMode = Val(tempz)   '1-text 2-icons+text 3-icons

      Getprivateprofilestring "All", "FontSize", "10", tempz, %Max_Path, INIFileName
      FontSize = Val(tempz)

      Getprivateprofilestring "All", "FontAttr", "1", tempz, %Max_Path, INIFileName
      FontAttr = Val(tempz)

      Getprivateprofilestring "All", "Selection", "1", tempz, %Max_Path, INIFileName
      Selection = Val(tempz) : If Selection = 0 Then Selection = 1

      Getprivateprofilestring "All", "OldHeight", "200", tempz, %Max_Path, INIFileName
      OldHeight = Val(tempz)

      Getprivateprofilestring "All", "SortByType", "0", tempz, %Max_Path, INIFileName
      SortByType = Val(tempz)
      Menu Set State hContext, ByCmd %IDM_SortByType, SortByType * 8

      Getprivateprofilestring "All", "AltColors", "0", tempz, %Max_Path, INIFileName
      AltColors = Val(tempz)
      Menu Set State hContext, ByCmd %IDM_AltColors, AltColors * 8

      Getprivateprofilestring "All", "IncludeExt", "0", tempz, %Max_Path, INIFileName
      IncludeExt = Val(tempz)
      Menu Set State hContext, ByCmd %IDM_IncludeExt, IncludeExt * 8

      Getprivateprofilestring "All", "MergeOpen", "0", tempz, %Max_Path, INIFileName
      MergeOpen = Val(tempz)
      Menu Set State hContext, ByCmd %IDM_Merge, MergeOpen * 8

      Getprivateprofilestring "All", "RollUp", "0", tempz, %Max_Path, INIFileName
      RollUp = Val(tempz)
      Menu Set State hContext, ByCmd %IDM_RollUp, RollUp * 8

      Getprivateprofilestring "All", "AutoSize", "0", tempz, %Max_Path, INIFileName
      AutoSize = Val(tempz)
      Menu Set State hContext, ByCmd %IDM_AutoSize, AutoSize * 8

      Getprivateprofilestring "All", "TopMost", "0", tempz, %Max_Path, INIFileName
      TopMost = Val(tempz)
      Menu Set State hContext, ByCmd %IDM_TopMost, TopMost * 8

      Getprivateprofilestring "All", "CommandLine", "0", tempz, %Max_Path, INIFileName
      CommandLine = Val(tempz)
      Menu Set State hContext, ByCmd %IDM_CommandLine, CommandLine * 8

      Getprivateprofilestring "All", "NamesOnly", "1", tempz, %Max_Path, INIFileName
      NamesOnly = Val(tempz)
      Menu Set State hContext, ByCmd %IDM_NamesOnly, NamesOnly * 8

      Getprivateprofilestring "All", "AppCount", "0", tempz, %Max_Path, INIFileName
      If Val(tempz) = 0 Then
          ReDim fNames(0), fHandlesL(0), fHandlesS(0)
      Else
          ReDim fNames(Val(tempz)), fHandlesL(Val(tempz)), fHandlesS(Val(tempz))
          For i = 1 To UBound(fNames)
             Getprivateprofilestring "All", "App" + Format$(i,"000"), "", tempz, %Max_Path, INIFileName
             fNames(i) = LCase$(tempz)
          Next i
      End If
   End If

   If Task$ = "save" Then
      If Len(Dir$(INIFileName)) Then Kill INIFileName
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If

      'save string variables
      WritePrivateProfileString "All", "LastSaveAs", (LastSaveAs), INIFileName
      WritePrivateProfileString "All", "FontName", (FontName), INIFileName
      WritePrivateProfileString "All", "ExeFiles", (ExeFiles), INIFileName
      WritePrivateProfileString "All", "DocFiles", (DocFiles), INIFileName

      'save numeric variable
      WritePrivateProfileString "All", "SortByType", (Str$(SortByType)), INIFileName
      WritePrivateProfileString "All", "AltColors", (Str$(AltColors)), INIFileName
      WritePrivateProfileString "All", "IncludeExt", (Str$(IncludeExt)), INIFileName
      WritePrivateProfileString "All", "MergeOpen", (Str$(MergeOpen)), INIFileName
      WritePrivateProfileString "All", "DisplayMode", (Str$(DisplayMode)), INIFileName
      WritePrivateProfileString "All", "FontSize", (Str$(FontSize)), INIFileName
      WritePrivateProfileString "All", "FontAttr", (Str$(FontAttr)), INIFileName
      WritePrivateProfileString "All", "Selection", (Str$(Selection)), INIFileName
      WritePrivateProfileString "All", "OldHeight", (Str$(OldHeight)), INIFileName
      WritePrivateProfileString "All", "RollUp", (Str$(RollUp)), INIFileName
      WritePrivateProfileString "All", "AutoSize", (Str$(AutoSize)), INIFileName
      WritePrivateProfileString "All", "TopMost", (Str$(TopMost)), INIFileName
      WritePrivateProfileString "All", "CommandLine", (Str$(CommandLine)), INIFileName
      WritePrivateProfileString "All", "NamesOnly", (Str$(NamesOnly)), INIFileName
      ListBox Get Select hDlg, %IDC_ListBox To Selection
      WritePrivateProfileString "All", "AppCount", (Str$(UBound(fNames))), INIFileName
      For i = 1 To UBound(fNames)
         If Len(fNames(i)) Then WritePrivateProfileString "All", "App" + Format$(i,"000"), (fNames(i)), INIFileName
      Next i

   End If
End Sub

Sub CreateContextMenu
   If Debug Then cPrint LCase$(FuncName$)
   Menu New PopUp To hOpenList

   Menu New PopUp To hContext
   Menu Add String, hContext, "Launch Selected Application",    %IDM_Launch,    %MF_Enabled
   Menu Add String, hContext, "Launch w/Command Line (One Time)",  %IDM_OpenWithCommand,    %MF_Enabled
   Menu Add String, hContext, "-",                   %IDM_Sep,    %MF_Enabled
   Menu Add String, hContext, "Remove Selection",    %IDM_RemoveSelection,    %MF_Enabled
   Menu Add String, hContext, "Remove All",          %IDM_RemoveAll,    %MF_Enabled
   Menu Add String, hContext, "-",                   %IDM_Sep,    %MF_Enabled
   Menu Add String, hContext, "Add File ...",        %IDM_AddFile,    %MF_Enabled
   Menu Add String, hContext, "Add Folder ...",      %IDM_AddFolder,    %MF_Enabled
   Menu Add String, hContext, "Add From Clipboard",  %IDM_AddFromClipboard,    %MF_Enabled
   Menu Add String, hContext, "Add All From Selected Folder ...", %IDM_IndexSelect,    %MF_Enabled
   Menu Add String, hContext, "Add All From Desktop", %IDM_IndexDesktop,    %MF_Enabled
   Menu Add String, hContext, "-",                   %IDM_Sep,    %MF_Enabled
   Menu Add String, hContext, "Open App Folder",     %IDM_OpenLocation,    %MF_Enabled
   Menu Add String, hContext, "Select Font",         %IDM_Font,    %MF_Enabled
   Menu Add String, hContext, "AutoSize Once",       %IDM_AutoSizeOnce,    %MF_Enabled
   Menu Add String, hContext, "-",                   %IDM_Sep,    %MF_Enabled
   Menu Add String, hContext, "Show Path",           %IDM_ShowPath,    %MF_Enabled
   Menu Add String, hContext, "Copy Path to Clipboard",  %IDM_CopyPath,    %MF_Enabled
   Menu Add String, hContext, "Copy Paths to Clipboard", %IDM_CopyPaths,    %MF_Enabled
   Menu Add String, hContext, "-",                   %IDM_Sep,    %MF_Enabled
   Menu Add String, hContext, "Sort Ascending",      %IDM_SortAscend,    %MF_Enabled
   Menu Add String, hContext, "Sort Descending",     %IDM_SortDescend,    %MF_Enabled
   Menu Add String, hContext, "-",                   %IDM_Sep,    %MF_Enabled
   Menu Add String, hContext, "Edit Executable Extensions", %IDM_EditExe,    %MF_Enabled
   Menu Add String, hContext, "Edit Document Extensions", %IDM_EditDoc,    %MF_Enabled
   Menu Add String, hContext, "-",                   %IDM_Sep,    %MF_Enabled
   Menu Add String, hContext, "Clean Command Line History",  %IDM_CleanCLHistory,    %MF_Enabled
   Menu Add String, hContext, "Clear Command Line History",  %IDM_ClearCLHistory,    %MF_Enabled
   Menu Add String, hContext, "-",                   %IDM_Sep,    %MF_Enabled
   Menu Add String, hContext, "Save List As ...",    %IDM_SaveList,    %MF_Enabled
   Menu Add PopUp,  hContext, "Open List",           hOpenList,    %MF_Enabled
   Menu Add String, hContext, "Open List Folder",    %IDM_OpenListFolder,    %MF_Enabled
   Menu Add String, hContext, "-",                   %IDM_Sep,    %MF_Enabled
   Menu Add String, hContext, "Text Only",           %IDM_TextOnly,    %MF_Enabled
   Menu Add String, hContext, "Text + Icons",        %IDM_TextAndIcons,    %MF_Enabled
   Menu Add String, hContext, "Icons Only",          %IDM_IconsOnly,    %MF_Enabled
   Menu Add String, hContext, "-",                   %IDM_Sep,    %MF_Enabled
   Menu Add String, hContext, "Short Names",          %IDM_NamesOnly,    %MF_Enabled
   Menu Add String, hContext, "Include Ext in Short Names", %IDM_IncludeExt,    %MF_Enabled
   Menu Add String, hContext, "Top Most",            %IDM_TopMost,    %MF_Enabled
   Menu Add String, hContext, "AutoSize",            %IDM_AutoSize,    %MF_Enabled
   Menu Add String, hContext, "AutoRollUp",          %IDM_RollUp,    %MF_Enabled
   Menu Add String, hContext, "Auto Command Line",   %IDM_CommandLine,    %MF_Enabled
   Menu Add String, hContext, "Merge on Open List",  %IDM_Merge,    %MF_Enabled
   Menu Add String, hContext, "Alternating Line Colors", %IDM_AltColors,    %MF_Enabled
   Menu Add String, hContext, "Sort by Type",        %IDM_SortByType,    %MF_Enabled
   Menu Add String, hContext, "-",                   %IDM_Sep,    %MF_Enabled
   Menu Add String, hContext, "Summary",             %IDM_Summary,    %MF_Enabled
   Menu Add String, hContext, "Exit No Save",        %IDM_ExitNoSave,    %MF_Enabled
   Menu Add String, hContext, "-",                   %IDM_Sep,    %MF_Enabled
   Menu Add String, hContext, "Help",                %IDM_Help,    %MF_Enabled
   Menu Add String, hContext, "About",               %IDM_About,    %MF_Enabled
End Sub

Function GetDroppedFileName(hDrop As Dword) As String
   If Debug Then cPrint LCase$(FuncName$)
   'David Gwillim July 2005
   Local fString As Asciiz*%Max_Path, Count As Long
   fString=Space$(%Max_Path)
   Count = DragQueryFile(hDrop,0,fString,Len(fString)-1)  ' put FileName(0) into fString and get character count
   Function = Left$(fString,Count)                           ' put Count chars into result string
End Function

Function GetLinkInfo(LinkPath As String ) As String
   If Debug Then cPrint LCase$(FuncName$)
   Local CLSID_ShellLink, IID_IShellLink As GUIDAPI
   Local CLSCTX_INPROC_SERVER, Flags, lResult As Dword
   Local FileData As WIN32_FIND_DATA
   Local IID_Persist As String * 16, pp, ppf, psl As Dword Ptr
   Local outvalue, TmpAsciiz As Asciiz * %Max_Path
   Local TmpWide As Asciiz * ( 2 * %Max_Path )
   Poke$ VarPtr(CLSID_ShellLink), Mkl$( &H00021401 ) + Chr$( 0, 0, 0, 0, &HC0, 0, 0, 0, 0, 0, 0, &H46 )
   Poke$ VarPtr(IID_IShellLink), Mkl$( &H000214EE ) + Chr$( 0, 0, 0, 0, &HC0, 0, 0, 0, 0, 0, 0, &H46 )
   IID_Persist = Mkl$( &H0000010B ) + Chr$( 0, 0, 0, 0, &HC0, 0, 0, 0, 0, 0, 0, &H46 )
   CLSCTX_INPROC_SERVER = 1
   If IsFalse( CoCreateInstance(CLSID_ShellLink, ByVal %NULL, CLSCTX_INPROC_SERVER, IID_IShellLink, psl )) Then
      pp = @psl: Call Dword @pp Using Sub3( ByVal psl, IID_Persist, ppf ) To lResult
      TmpAsciiz = LinkPath
      MultiByteToWideChar %CP_ACP, 0, TmpAsciiz, %Max_Path, ByVal VarPtr(TmpWide), 2 * %Max_Path
      pp = @ppf + 20: Call Dword @pp Using Sub3( ByVal ppf, TmpWide, ByVal %TRUE )
      pp = @psl + 12: Call Dword @pp Using Sub5( ByVal psl, outvalue, ByVal %Max_Path, FileData, Flags )  'GetFilePath
      pp = @ppf + 8: Call Dword @pp Using Sub1( ByVal ppf )      'Release the persistant file
      pp = @psl + 8: Call Dword @pp Using Sub1( ByVal psl )      'Unbind the shell link object from the persistent file
      Function = outvalue
   End If
End Function

Function MsgBoxX(msg$,Flag As Long,caption$) As Long
   If Debug Then cPrint LCase$(FuncName$)
   Local OldTopMost As Long
   OldTopMost = TopMost : TopMost = %False : SetOntop
   hHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
   Function = MessageBox( 0, (msg$), (caption$), Flag)
   TopMost = OldTopMost : SetOnTop
End Function

Sub CenterOverDialog(BoxX As Long, BoxY As Long, CenterX As Long, CenterY As Long)
   'gets top/left position to center Box over Dialog
   'you need to know, or at least estimate, the Box size
   Local x As Long, y As Long, w As Long, h As Long
   Dialog Get Loc hDlg To x,y
   Dialog Get Size hDlg To w,h
   CenterX = x + (w-BoxX)/2
   CenterY = y + (h-BoxY)/2
End Sub

Function SBProc(ByVal lMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x As Long, y As Long    'MsgBoxX is approximately 200x200
   CenterOverDialog 370,170,x,y
   If lMsg = %HCBT_ACTIVATE Then
      SetWindowPos wParam, 0, x,y, 0, 0, %SWP_NOSIZE Or %SWP_NOACTIVATE Or %SWP_NOZORDER
      UnhookWindowsHookEx hHook
   End If
End Function

Sub SetOnTop
    If Debug Then cPrint LCase$(FuncName$)
    If TopMost Then
       SetWindowPos(hDlg, %HWND_TOPMOST, 0, 0, 0, 0, %SWP_NOMOVE Or %SWP_NOSIZE)  'on Top
    Else
       SetWindowPos(hDlg, %HWND_NOTOPMOST, 0, 0, 0, 0, %SWP_NOMOVE Or %SWP_NOSIZE) 'not on Top
    End If
End Sub

Sub LaunchSelection
   If Debug Then cPrint LCase$(FuncName$)
   Local x,y,iResult,OldTopMost As Long, CL$, temp$, fData$, ProcessID As Dword
   ListBox Get Select hDlg, %IDC_ListBox To iResult
   If iResult Then
       If IsFolder(fNames(iResult)) Then
           iResult = ShellExecute(hDlg, "Open", (fNames(iResult)), $Nul, $Nul, %SW_ShowNormal)
       ElseIf Left$(fNames(iResult),7)="http://" Then
           iResult = ShellExecute(hDlg, "Open", (fNames(iResult)), $Nul, $Nul, %SW_ShowNormal)
       ElseIf InStr(ExeFiles,Right$(fNames(iResult),4)) Then
           If CommandLine Then
               OldTopMost = TopMost : TopMost = %False : SetOntop
               CenterOverDialog(300,225,x,y)
               CL$ = GetCLHistory(fNames(iResult))
               temp$ = InputBox$("Enter command line.", "Command Line", CL$, x,y)
               If Len(Trim$(temp$)) Then
                   'put new app/cl pair at top of file
                   Open EXE.Path$ + "clhistory.txt" For Binary As #1
                   Get$ #1, Lof(1), fData$
                   Close #1
                   Open EXE.Path$ + "clhistory.txt" For Output As #1
                   Print #1, fNames(iResult)
                   Print #1, temp$
                   Print #1, fData$
                   Close #1
                   ProcessID = Shell(fNames(iResult) + " " + temp$,1)
               End If
               TopMost = OldTopMost : SetOnTop
           Else
               ProcessID = Shell(fNames(iResult),1)
           End If
       ElseIf InStr(DocFiles,Right$(fNames(iResult),4)) Then
           iResult = ShellExecute(hDlg, "Open", (fNames(iResult)), $Nul, $Nul, %SW_ShowNormal)
       End If
   End If
   If RollUp Then RollUpWindow
End Sub

Sub AutoSizeListBox
    If Debug Then cPrint LCase$(FuncName$)
    Local iCount,iSize As Long
    ListBox Get Count hDlg, %IDC_ListBox To iCount
    Control Send hDlg, %IDC_ListBox, %LB_GetItemHeight,0,0 To iSize
    Dialog Set Client hDlg, MaxWidth, iCount * iSize + 5
End Sub

Function InstanceTest() As Long
   If Debug Then cPrint LCase$(FuncName$)
   'returns 0 if instance exits or cannot create mutex. otherwise returns 1.
   Local UniqueName As Asciiz * %Max_Path
   UniqueName = "gbLaunch"                     '
   If CreateMutex(ByVal %Null, 0, UniqueName) = 0 _
         Or GetLastError = %ERROR_ALREADY_EXISTS Then Exit Function Else Function = 1
End Function

Function IsUnique(temp$) As Long
    If Debug Then cPrint LCase$(FuncName$)
    Local i As Long
    For i = 1 To UBound(fNames)
        If LCase$(temp$) = LCase$(fNames(i)) Then Function = 0 : Exit Function
    Next i
    Function = 1
End Function

Sub RollUpWindow
    If Debug Then cPrint LCase$(FuncName$)
    Local w,h As Long
    'rollup
    Dialog Get Client hDlg To w,h
    If h < 5 Then
        Dialog Set Client hDlg, w, OldHeight
    Else
        OldHeight = h
        Dialog Set Client hDlg, w, 0
    End If
    'relocation if off screen
End Sub

Function MaxWidth() As Long
    If Debug Then cPrint LCase$(FuncName$)
    Local i,iCount,w,h,iMaxWidth, DMargin As Long, temp$
    ListBox Get Count hDlg, %IDC_ListBox To iCount
    If DisplayMode = 3 Then
        Function = imgWL + 100
    Else
        If DisplayMode = 1 Then DMargin = 3
        If DisplayMode = 2 Then DMargin = 3*%IconMargin + imgWS
        For i = 1 To iCount
            ListBox Get Text hDlg, %IDC_ListBox, i To temp$
            Graphic Text Size temp$ To w,h
            iMaxWidth = Max(iMaxWidth,w+DMargin+20)
        Next i
        Function = Max(iMaxWidth,130)
    End If
End Function

Sub SelectListBoxFont
   If Debug Then cPrint LCase$(FuncName$)
   Local fName As String, fPoints, fStyle, fColor, CharSet, Style As Long
   Style = %CF_ScreenFonts Or %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations
   Display Font hDlg, 100,100, FontName, FontSize, FontAttr, Style To fName, fPoints, fStyle, fColor, CharSet
   If Len(fName) Then
       FontName = fName : FontSize = fPoints : FontAttr = fStyle
       Font New FontName, FontSize, FontAttr To hFont
       Control Set Font hDlg, %IDC_ListBox, hFont
       Graphic Set Font hFont
       SetRowHeight
       If AutoSize Then AutoSizeListBox
   End If
End Sub

Function GetCLHistory(temp$) As String
    If Debug Then cPrint LCase$(FuncName$)
    On Error GoTo CLError
    Local fPath$, CL$
    If IsFalse IsFile(EXE.Path$ + "clhistory.txt") Then Exit Function
    Open EXE.Path$ + "clhistory.txt" For Input As #1
    Do While IsFalse Eof(1)
       Line Input #1, fPath$
       Line Input #1, CL$
       If LCase$(fPath$) = LCase$(temp$) Then Exit Loop
    Wend
    Close #1
    Function = CL$
    Exit Function
CLError:
End Function

Sub CleanCLHistory
    If Debug Then cPrint LCase$(FuncName$)
    Local dPath$,dCL$,d$, iCount As Long
    Dim CLHistory(100000) As String         'arbitrarily large

    d$ = ":::+++:::"

    'put pairs into array, separated by :::
    Open EXE.Path$ + "clhistory.txt" For Input As #1
    While IsFalse Eof(1)
        Line Input #1, dPath$
        Line Input #1, dCL$
        CLHistory(iCount) = dPath$ + d$ + dCL$
        Incr iCount
    Wend
    Close #1
    ReDim Preserve CLHistory(iCount-1)

    'remove dupes
    Local i,r,t,j As Long
    iCount = 0
    For j = 0 To UBound(CLHistory)
       r = InStr(CLHistory(j),d$)
       For i = UBound(CLHistory) To j+1 Step -1
          t = InStr(CLHistory(i),d$)
          If Left$(CLHistory(j),r-1) = Left$(CLHistory(i),t-1) Then Array Delete CLHistory(i) : Incr iCount
       Next i
    Next j
    ReDim Preserve CLHistory(UBound(CLHistory)-iCount)

    'rebuild CLHistory.txt
    Open EXE.Path$ + "clhistory.txt" For Output As #1
    For i = 0 To UBound(CLHistory)
        Replace d$ With $CrLf In CLHistory(i)
        If Trim$(d$) <> $CrLf Then Print #1, CLHistory(i)
    Next i
    Close #1

End Sub

Sub SetDisplayModeMenus
   If Debug Then cPrint LCase$(FuncName$)
   Menu Set State hContext, ByCmd %IDM_TextOnly, 0
   Menu Set State hContext, ByCmd %IDM_IconsOnly, 0
   Menu Set State hContext, ByCmd %IDM_TextAndIcons, 0
   Select Case DisplayMode
       Case 1 : Menu Set State hContext, ByCmd %IDM_TextOnly, 8
       Case 2 : Menu Set State hContext, ByCmd %IDM_TextAndIcons, 8
       Case 3 : Menu Set State hContext, ByCmd %IDM_IconsOnly, 8
   End Select
End Sub

Sub GetImageSizes
   If Debug Then cPrint LCase$(FuncName$)
   'system large
   imgWL = GetSystemMetrics(%SM_cxIcon)
   imgHL = GetSystemMetrics(%SM_cyIcon)
   'system small
   imgWS = GetSystemMetrics(%SM_cxsmIcon)
   imgHS = GetSystemMetrics(%SM_cysmIcon)
End Sub

Sub SetRowHeight
    If Debug Then cPrint LCase$(FuncName$)
    Local w As Long
    Graphic Bitmap New 10,10 To hBMP : Graphic Attach hBMP,0 : Graphic Set Font hFont
    Graphic Text Size "A" To w,RowHeight
    Select Case DisplayMode
        Case 1: Control Send hDlg, %IDC_ListBox, %LB_SetItemheight, 0, RowHeight+4              ' Set the line height to fit the Font
        Case 2: Control Send hDlg, %IDC_ListBox, %LB_SetItemheight, 0, Max(RowHeight+4,imgHS+4) ' Set the line height to fit the Font
        Case 3: Control Send hDlg, %IDC_ListBox, %LB_SetItemheight, 0, imgHL+4                  ' Set the line height to fit the Image
    End Select
End Sub

Sub BuildAcceleratorTable
   If Debug Then cPrint LCase$(FuncName$)
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(13)
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_Right  : ac(c).cmd   = %IDM_Right            : Incr c
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_Left   : ac(c).cmd   = %IDM_Left             : Incr c
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F1     : ac(c).cmd   = %IDM_Help             : Incr c
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_Delete : ac(c).cmd   = %IDM_RemoveSelection  : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_S      : ac(c).cmd   = %IDM_SaveList         : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_N      : ac(c).cmd   = %IDM_NamesOnly        : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_A      : ac(c).cmd   = %IDM_AutoSizeOnce     : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_M      : ac(c).cmd   = %IDM_CycleMode        : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_F      : ac(c).cmd   = %IDM_OpenLocation     : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_T      : ac(c).cmd   = %IDM_TopMost          : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_V      : ac(c).cmd   = %IDM_AddFromClipboard : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_D      : ac(c).cmd   = %IDM_ToggleDebug      : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_C      : ac(c).cmd   = %IDM_CopyPaths        : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_R      : ac(c).cmd   = %IDM_ClearConsole     : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Sub ReArrangeListBoxItems(StartItem As Long, EndItem As Long)
   If Debug Then cPrint LCase$(FuncName$)
   'place startitem in the position of enditem. maintain order above end position
   Local startText As String, i As Long
   Incr StartItem : Incr EndItem    'arguments are zero-based values

   startText = fNames(StartItem)

   If StartItem < EndItem Then     'start is above end
      For i = StartItem To EndItem-1
         fNames(i)    = fNames(i+1)
      Next i
      fNames(EndItem)    = startText
   Else                           'end is above start
      For i = StartItem To EndItem+1 Step -1
         fNames(i)    = fNames(i-1)
      Next i
      fNames(EndItem)    = startText
   End If
End Sub

Function SelectFolder() As String
   If Debug Then cPrint LCase$(FuncName$)
   Local title$, start$, flags&, folder$
   title$ = "Select Index Folder"
   start$ = EXE.Path$
   flags& = %BIF_ReturnOnlyFSDirs Or %BIF_DontGoBelowDomain Or %BIF_NoNewFolderButton
   Display Browse  hDlg, 100, 100, title$, start$, flags& To folder$   'folder$ is set to "" if Cancel/Escape is pressed
   If IsFolder(folder$) Then Function  = folder$
End Function

Sub EditDocFileList
    If Debug Then cPrint LCase$(FuncName$)
    Local x,y As Long, temp$
    CenterOverDialog(300,225,x,y)
    temp$ = InputBox$("Edit document extensions.", "Document List", DocFiles, x,y)
    If Len(temp$) Then DocFiles = LCase$(temp$)
End Sub

Sub EditExeFileList
    If Debug Then cPrint LCase$(FuncName$)
    Local x,y As Long, temp$
    CenterOverDialog(300,225,x,y)
    temp$ = InputBox$("Edit executable extensions.", "Executable List", ExeFiles, x,y)
    If Len(temp$) Then ExeFiles = LCase$(temp$)
End Sub

Sub AddFromClipboard
    If Debug Then cPrint LCase$(FuncName$)
    Local temp$
    Clipboard Get Text To temp$
    temp$ = Parse$(temp$,$CrLf,1)
    AddNewApplication temp$
    BuildListBox
    ListBox Get Count hDlg, %IDC_ListBox To Selection
    ListBox Select hDlg, %IDC_ListBox,Selection
End Sub

Sub ShowPath
    If Debug Then cPrint LCase$(FuncName$)
    Local iResult As Long
    ListBox Get Select hDlg, %IDC_ListBox To iResult
    If iResult Then MsgBoxX fNames(iResult), %MB_Ok + %MB_IconInformation, "Show Path"
End Sub

Sub CreateTempHTM
    If Debug Then cPrint LCase$(FuncName$)
    Open EXE.Path$ + "temp.htm" For Output As #1
    Close #1
End Sub

Sub ClearHandles
    If Debug Then cPrint LCase$(FuncName$)
    'delete icon handles/objects
    Local i As Long
    For i = 1 To UBound(fHandlesL)
        If fHandlesL(i) Then DestroyIcon fHandlesL(i)
        If fHandlesS(i) Then DestroyIcon fHandlesS(i)
    Next i
End Sub

Sub AddNewApplication(ByVal temp$)
   If Debug Then cPrint LCase$(FuncName$)
   Local UBF,Flag As Long
   'put temp$ into valid format
   Replace Chr$(34) With "" In temp$
   temp$ = LCase$(Trim$(temp$))
   If temp$ = "" Then Exit Sub
   If Right$(temp$,4) = ".lnk" Then temp$ = LCase$(GetLinkInfo(temp$))

   'verify file is acceptable
   If IsFolder(temp$) Then
       Flag = 1
   ElseIf Left$(temp$,7)="http://" Then
       Flag = 1     'URL
'   ElseIf Len(Dir$(temp$)) Then                                      'valid file
   ElseIf IsFile(temp$) Then                                      'valid file
       If InStr(ExeFiles+DocFiles,Right$(temp$,4)) Then Flag = 1     'managed extension
   Else
       'Beep
       MsgBoxX "Invalid application!" + $CrLf + $CrLf + temp$, %MB_Ok + %MB_IconExclamation, "Add New Application"
   End If

   'add file to fNames()
   If Flag Then
       If IsUnique(temp$) Then
           UBF = UBound(fNames)+1
           ReDim Preserve fNames(UBF), fHandlesL(UBF), fHandlesS(UBF)
           fNames(UBF) = temp$
           ListBox Select hDlg, %IDC_ListBox, UBF
       Else
           'Beep
           MsgBoxX "Duplicate application!" + $CrLf + $CrLf + temp$, %MB_Ok + %MB_IconExclamation, "Drop File"
       End If
   End If
End Sub

Sub BuildListBox
    If Debug Then cPrint LCase$(FuncName$)
    'build from scratch using fNames().  get new handles on all icons
    Local i,iResult As Long, tmp$, temp$, ExeName As Asciiz * %Max_Path
    ListBox Get Select hDlg, %IDC_ListBox To Selection
    ClearHandles
    SendMessage GetDlgItem(hDlg,%IDC_ListBox),%WM_SetRedraw,0,0  'stop flicker
    ListBox Reset hDlg, %IDC_ListBox
    'add item to ListBox
    For i = 1 To UBound(fNames)
        temp$ = fNames(i)
        If NamesOnly Then
            If IsFolder(temp$) Then
                ListBox Add hDlg, %IDC_ListBox, temp
            ElseIf Left$(temp$,7) = "http://" Then
                tmp$ = Right$(temp$, Len(temp$)-InStr(-1,temp$,"/"))
                If Trim$(tmp$) = "" Then
                    ListBox Add hDlg, %IDC_ListBox, temp$
                Else
                    ListBox Add hDlg, %IDC_ListBox, tmp$+" (url)
                End If
            Else
                ListBox Add hDlg, %IDC_ListBox, IIf$(IncludeExt,PathName$(Namex,temp$),PathName$(Name,temp$))
            End If
        Else
            ListBox Add hDlg, %IDC_ListBox, temp$
        End If

        'get icon handles for the item
        If IsFolder(temp$) Then
             iResult = ExtractIconEx((EXE.Full$),2,L(0),S(0),2)   'folder icon
        ElseIf Left$(temp$,7) = "http://" Then
            FindExecutable(EXE.Path$ + "temp.htm",ByVal %Null,EXEName)
            iResult = ExtractIconEx((ExeName),0,L(0),S(0),2)
        ElseIf InStr(ExeFiles,PathName$(Extn,temp$)) Then
            iResult = ExtractIconEx((temp$),0,L(0),S(0),2)
        ElseIf InStr(DocFiles,PathName$(Extn,temp$)) Then
            FindExecutable((temp$),ByVal %Null,EXEName)
            iResult = ExtractIconEx((ExeName),0,L(0),S(0),2)
        End If
        If iResult < 1 Then iResult = ExtractIconEx((EXE.Full$),1,L(0),S(0),2)
        fHandlesL(i) = L(0)
        fHandlesS(i) = S(0)
    Next i
    SendMessage GetDlgItem(hDlg,%IDC_ListBox),%WM_SetRedraw,1,0
    ListBox Select hDlg, %IDC_ListBox, Selection
    If AutoSize Then AutoSizeListBox
End Sub

Sub SortList(Flag As Long)    '0=ascending 1=descending
   If Debug Then cPrint LCase$(FuncName$)
   Local i As Long, temp$
   'create list of short name
   Dim sArray(UBound(fNames)) As String
   For i = 1 To UBound(fNames)
      temp$ = fNames(i)
      If IsFolder(temp$) Then
          sArray(i) = IIf$(SortByType,"folder","") + temp$
      ElseIf Left$(temp$,7) = "http://" Then
          sArray(i) = temp$
      Else
          If NamesOnly Then
             sArray(i) = IIf$(IncludeExt,PathName$(Namex,temp$),PathName$(Name,temp$))
          Else
             sArray(i) = temp$
          End If
          sArray(i) = IIf$(SortByType,PathName$(Extn,sArray(i)),"") + sArray(i)
      End If
   Next i
   'sort short name array, with fNames at tag array
   If Flag Then
      Array Sort sArray(1), TagArray fNames(), Descend
   Else
      Array Sort sArray(1), TagArray fNames(), Ascend
   End If
End Sub

Sub BuildListMenu
    If Debug Then cPrint LCase$(FuncName$)
    Local i,iCount As Long, temp$
    'delete menu items
    For i = 1001 To 1100
       Menu Delete hOpenList, ByCmd i
    Next i
    'create menu items
    temp$ = Dir$(EXE.Path$ + "lists\*.ini")
    For i = 1001 To 1100
       If Len(temp$)= 0 Then Exit For
       Menu Add String, hOpenList, temp$, i, %MF_Enabled
       Incr iCount
       temp$ = Dir$
    Next i
    If iCount = 0 Then Menu Add String, hOpenList, "<no lists found>", 1000, %MF_Enabled
End Sub

Sub SaveList
    If Debug Then cPrint LCase$(FuncName$)
    Local temp$,fName$,x,y,OldTopMost As Long
    OldTopMost = TopMost : TopMost = %False : SetOntop
    CenterOverDialog(300,225,x,y)
    fName$ = LastSaveAs
    CenterOverDialog(300,225,x,y)
    temp$ = InputBox$("Enter file name:" + $CrLf + "(no extension):", "Save List", fName$, x,y)
    If Len(Trim$(temp$)) Then
        LastSaveAs = temp$
        Listing_INI "save", EXE.Path$ + "lists\" + temp$ + ".ini"
    End If
    TopMost = OldTopMost : SetOnTop
End Sub

Sub Listing_INI(Task$, ListFileName$)
   If Debug Then cPrint LCase$(FuncName$)
   Local i,iCount,ItemCount As Long, tempz As Asciiz * %Max_Path

   If Task$ = "merge" Then
      Getprivateprofilestring "All", "ItemCount", "0", tempz, %Max_Path, (ListFileName$)
      ItemCount = Val(tempz)
      iCount = UBound(fNames)
      ReDim Preserve fNames(iCount+ItemCount), fHandlesL(iCount+ItemCount), fHandlesS(iCount+ItemCount)
      For i = iCount+1 To iCount+ItemCount
         Getprivateprofilestring "All", "Item" + Format$(i-iCount,"000"), "", tempz, %Max_Path, (ListFileName$)
         fNames(i) = LCase$(tempz)
      Next i
      RemoveDupes  'remove duplicates in fNames()
   End If
   If Task$ = "get" Then
      Getprivateprofilestring "All", "ItemCount", "0", tempz, %Max_Path, (ListFileName$)
      ItemCount = Val(tempz)
      ReDim fNames(ItemCount), fHandlesL(ItemCount), fHandlesS(ItemCount)
      For i = 1 To ItemCount
         Getprivateprofilestring "All", "Item" + Format$(i,"000"), "", tempz, %Max_Path, (ListFileName$)
         fNames(i) = LCase$(tempz)
      Next i
   End If
   If Task$ = "save" Then
      'save numeric variable
      If Len(Dir$(ListFileName$)) Then Kill ListFileName$  'to remove all previous content
      WritePrivateProfileString "All", "ItemCount", (Str$(UBound(fNames))), (ListFileName$)
      For i = 1 To UBound(fNames)
         If Len(fNames(i)) Then WritePrivateProfileString "All", "Item" + Format$(i,"000"), (fNames(i)), (ListFileName$)
      Next i
   End If
End Sub

Sub DisplaySummary
    If Debug Then cPrint LCase$(FuncName$)
    Local i As Long, temp$
    temp$ = "Items in list: " + Str$(UBound(fNames)) + $CrLf
    For i = 1 To UBound(fNames)
        temp$ = temp$ + $CrLf + Format$(i,"000 ") + Left$(fNames(i),45) + IIf$(Len(fNames(i))>45,"...","")
    Next i
    MsgBoxX("gbLaunch " + $ver + $CrLf + $CrLf + temp$, %MB_Ok+%MB_IconInformation, "About") 'test purposes
End Sub

Sub CPrint (SOut As String)
   Static cWritten As Long
   Incr iMsgCount
   SOut = Str$(iMsgCount) + " " + SOut
   If hConsole = 0 Then AllocConsole: hConsole = GetStdHandle(-11&)
   WriteConsole hConsole, ByCopy sOut + $CrLf, Len(sOut) + 2, cWritten, ByVal 0&
   Control Set Focus hDlg, %IDC_ListBox
End Sub

Sub ClearConsole
   If Debug Then cPrint LCase$(FuncName$)
   Local hWrittenChars As Long
   Local tConsoleInfo As CONSOLE_SCREEN_BUFFER_INFO
   GetConsoleScreenBufferInfo(hConsole, tConsoleInfo)
   FillConsoleOutputCharacter(hConsole, 32, tConsoleInfo.dwSize.x * tConsoleInfo.dwSize.y, Mak(Dword,0,0), hWrittenChars)
   SetConsoleCursorPosition(hConsole, Mak(Dword,0,0))
   Sleep 500   'time for cursor to move off ListView
End Sub

Function AddFolder() As String
   If Debug Then cPrint LCase$(FuncName$)
   Local title$, start$, flags&, folder$
   title$ = "Select Folder"
   start$ = EXE.Path$
   flags& = %BIF_ReturnOnlyFSDirs Or %BIF_DontGoBelowDomain Or %BIF_NoNewFolderButton
   Display Browse  hDlg, 100, 100, title$, start$, flags& To folder$   'folder$ is set to "" if Cancel/Escape is pressed
   If Len(folder$) Then Function = folder$
End Function

Function AddFile() As String
    If Debug Then cPrint LCase$(FuncName$)
    Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    title$ = "Select File"
    filter$ = "All Files" + $Nul + "*.*" + $Nul
    startfolder$ = EXE.Path$
    startfile$ = ""
    defaultext$ = ""
    flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
    Display Openfile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then Function = filevar$
End Function

Sub RemoveDupes          '1 array, no sorting
   If Debug Then cPrint LCase$(FuncName$)
   Local iMax,i,j,iResult As Long
   iMax = UBound(fNames)
   For i = 0 To iMax - 1
      For j = i+1 To iMax
         If fNames(i) = fNames(j) Then Array Delete fNames(j) : Decr iMax
      Next j
   Next i
   ReDim Preserve fNames(iMax)
End Sub

Sub IndexDesktopFolder
   If Debug Then cPrint LCase$(FuncName$)
   Local sPath As Asciiz * %MAX_PATH
   SHGetFolderPath(0, %CSIDL_DeskTop, 0, 0, sPath)
'   ShellExecute(hDlg, "Open", sPath, $Nul, $Nul, %SW_Restore)
   If IsFolder(sPath) Then IndexFolder((sPath))
End Sub

Sub IndexStartFolder
   If Debug Then cPrint LCase$(FuncName$)
   Local sPath As Asciiz * %MAX_PATH
   SHGetFolderPath(0, %CSIDL_Startup, 0, 0, sPath)
'   ShellExecute(hDlg, "Open", sPath, $Nul, $Nul, %SW_Restore)
   If IsFolder(sPath) Then IndexFolder((sPath))
End Sub

Sub IndexSelectFolder
   If Debug Then cPrint LCase$(FuncName$)
   Local temp$
   temp$ = SelectFolder
   If IsFolder(temp$) Then IndexFolder(temp$)
End Sub

Sub IndexFolder(folder$)
    If Debug Then cPrint LCase$(FuncName$)
    Local temp$,tmp$,t$
    If IsFolder(folder$) Then
        'all all EXEs in folder
        temp$ = Dir$(folder$ + "\*.*")
        While Len(temp$)
           tmp$ = LCase$(folder$ + "\" + temp$)
           AddNewApplication ((tmp$))
           temp$ = Dir$(Next)
        Wend
        ListBox Get Count hDlg, %IDC_ListBox To Selection
        BuildListBox
        ListBox Select hDlg, %IDC_ListBox,IIf(Selection,Selection,1)
    Else
        MsgBoxX "Invalid folder!", %MB_Ok+%MB_IconExclamation, "Index Folder"
    End If
End Sub
